<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>AdminLTE 3 | Dashboard 3</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome Icons -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- IonIcons -->
  <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  
</head>
<!--
`body` tag options:

  Apply one or more of the following classes to to the body tag
  to get the desired effect

  * sidebar-collapse
  * sidebar-mini
-->
<body class="hold-transition sidebar-mini">
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Devcamp120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user panel (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">uyendtn</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="./index.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Users</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="./index2.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Vouchers</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="./index3.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Orders</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Orders List</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Orders list</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <div class="content">
      <div class="container-fluid">
        <div class="container jumbotron">
          <div class="row form-group text-center">
              <div class="col-sm-2">
                  <label>Trạng thái Order</label>
              </div>
              <div class="col-sm-3">
                  <select  class="form-select" id="select-order-status" style="width:200px">
                      <option value = 0>(all)</option>
                      <option value = 1>Open</option>
                      <option value = 2>Confirmed</option>
                      <option value = 3>Cancel</option>
                  </select>
              </div>
              <div class="col-sm-2">
                  <label>Loại pizza</label>
              </div>
              <div >
                  <select  class="form-select" id="select-pizza-type" style="width:200px">
                      <option value = 0>(all)</option>
                      <option value = 1>Hawaii</option>
                      <option value = 2>Bacon</option>
                      <option value = 3>Seafood</option>
                  </select>
              </div>
              <div class="col-sm-2">
                  <input id="btn-filter" type="submit" class="btn btn-primary btn-sm" value="Lọc" style="width:100px">
              </div>
          </div>
        </div>
        
        <table class="table table-bordered table-striped table-hover" id="order-table">
          <thead>
            <tr>
              <th>orderId</th>
              <th>Kích cỡ combo</th>
              <th>Loại pizza</th>
              <th>Nước uống</th>
              <th>Thành tiền</th>
              <th>Họ và tên</th>
              <th>Số điện thoại</th>
              <th>Trạng thái</th>
              <th>Chi tiết</th>
            </tr>
        </table>
        <!-- /.row -->
      </div>
      <!-- /.container-fluid -->
    </div>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->

  <!-- Main Footer -->
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.2.0
    </div>
  </footer>
</div>
<!-- ./wrapper -->

<!-- REQUIRED SCRIPTS -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>

<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.1.1/js/all.min.js" integrity="sha512-6PM0qYu5KExuNcKt5bURAoT6KCThUmHRewN3zUFNaoI6Di7XJPTMoT6K0nsagZKk2OB4L7E3q1uQKHNHd4stIQ==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
<!-- AdminLTE -->
<script src="dist/js/adminlte.js"></script>

<!-- OPTIONAL SCRIPTS -->
<script src="plugins/chart.js/Chart.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>
<!-- AdminLTE dashboard demo (This is only for demo purposes) -->
<script src="dist/js/pages/dashboard3.js"></script>

<script>
  "use strict";
  $(document).ready(function() {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gCOLUMN_ORDER_ID = 0;
    const gCOLUMN_COMBO_SIZE = 1;
    const gCOLUMN_PIZZA_TYPE = 2;
    const gCOLUMN_DRINK = 3;
    const gCOLUMN_PRICE = 4 ;
    const gCOLUMN_NAME = 5;
    const gCOLUMN_PHONE = 6;
    const gCOLUMN_STATUS = 7;
    const gCOLUMN_DETIAL = 8;
    
    var gOrderListColumns = ["orderId", "kichCo","loaiPizza","idLoaiNuocUong","thanhTien","hoTen","soDienThoai","trangThai","chiTiet"]

    var gAllOrders = [];
    var gDrinkList = [];
    // định nghĩa table  - chưa có data
    var gOrderTable = $("#order-table").DataTable( {
      // Khai báo các cột của datatable
      "columns" : [
          { "data" : gOrderListColumns[gCOLUMN_ORDER_ID] },
          { "data" : gOrderListColumns[gCOLUMN_COMBO_SIZE] },
          { "data" : gOrderListColumns[gCOLUMN_PIZZA_TYPE] },
          { "data" : gOrderListColumns[gCOLUMN_DRINK] },
          { "data" : gOrderListColumns[gCOLUMN_PRICE] },
          { "data" : gOrderListColumns[gCOLUMN_NAME] },
          { "data" : gOrderListColumns[gCOLUMN_PHONE] },
          { "data" : gOrderListColumns[gCOLUMN_STATUS] },
          { "data" : gOrderListColumns[gCOLUMN_DETIAL] }
    ],
          
      // Ghi đè nội dung của cột action, chuyển thành button chi tiết
      "columnDefs": [ 
      {
          "targets": gCOLUMN_DETIAL,
          "defaultContent": "<button class='info-order fa fa-info-circle'></button>"
      },
      {
          "targets": gCOLUMN_DRINK,
          "render": function(data){
            for (let bI = 0; bI<gDrinkList.length; bI++){
                if (data == gDrinkList[bI].maNuocUong){ 
                return gDrinkList[bI].tenNuocUong
           } 
            } 
          }
      },
    ]
    });
    
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();

    // gán click event handler cho button chi tiet
    $("#order-table").on("click", ".info-order", function() {
      onButtonChiTietClick(this); // this là button được ấn
    });
    // gán click event handler cho button filter
    $('#btn-filter').on('click',function(){
        onBtnFilterClick(this);
    })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
    // infoFunction sẽ là function các nút cùng gọi
    function onButtonChiTietClick(paramChiTietButton) {
      //Xác định thẻ tr là cha của nút được chọn
      var vRowSelected = $(paramChiTietButton).parents('tr');
      //Lấy datatable row
      var vDatatableRow = gOrderTable.row(vRowSelected); 
      //Lấy data của dòng 
      var vOrderData = vDatatableRow.data();
      var vOrderId = vOrderData.orderId;
      var vKichCo = vOrderData.kichCo;  
      var vLoaiPizza = vOrderData.loaiPizza;    
      var vNuocUong= vOrderData.tenNuocUong;    
      var vThanhTieng= vOrderData.thanhTien;    
      var vHoTen= vOrderData.hoTen;    
      var vSoDienThoai= vOrderData.soDienThoai;    
      var vTrangThai= vOrderData.trangThai;    
      
      console.log(vOrderId);
      console.log(vKichCo);
      console.log(vLoaiPizza);
      console.log(vNuocUong);
      console.log(vThanhTieng);
      console.log(vHoTen);
      console.log(vSoDienThoai);
      console.log(vTrangThai);
    }

    function onBtnFilterClick(paramFilterButton){
        var vSelectObject = {
            loaiPizza: "",
            trangThai: ""
        }
        //1. thu thập dữ liệu để filter
        getFilterData(vSelectObject)
        //2. validate không có
        //3. filter dữ liệu
        var vFilterResult = filterData(vSelectObject)
        //4. hiển thị kêt quả filter
        loadDataToTable(vFilterResult)
    }

    // hàm chạy khi trang được load
    function onPageLoading() {
      // lấy data từ server
      $.ajax({
        url: "http://42.115.221.44:8080/devcamp-pizza365/orders",
        type: "GET",
        dataType: 'json',
        async:false,
        success: function(responseObject){
            gAllOrders = responseObject
            console.log(gAllOrders)
          
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });

      $.ajax({
        url: "http://42.115.221.44:8080/devcamp-pizza365/drinks",
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
            gDrinkList = responseObject
            console.log(gDrinkList)
          //mappingDrinkList(responseObject);
          loadDataToTable(gAllOrders);
        },
        error: function(error){
          console.assert(error.responseText);
        }
      })
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
    //hàm filter
    function filterData(paramSelectObject){
       var vFilterResult = gAllOrders.filter(function(paramFilterElement){
            return ((paramSelectObject.loaiPizza.toLowerCase().includes(paramFilterElement.loaiPizza.toLowerCase())||paramSelectObject.loaiPizza=="(all)")
            &&(paramSelectObject.trangThai.toLowerCase().includes(paramFilterElement.trangThai.toLowerCase())||paramFilterElement.trangThai=="(all)"))
        })
        return vFilterResult
    }
    //hàm thu thập thông tin filter
    function getFilterData(paramSelectObject){
        paramSelectObject.trangThai = $('#select-order-status option:selected').text()
        paramSelectObject.loaiPizza = $('#select-pizza-type option:selected').text()
    }
    // load data to table
    function loadDataToTable(paramResponseObject) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      gOrderTable.clear();
      //Cập nhật data cho bảng 
      gOrderTable.rows.add(paramResponseObject);
      //Cập nhật lại giao diện hiển thị bảng
      gOrderTable.draw();
    }
    
  });
</script>
</body>
</html>
